//
//   Draw.cpp
//
#include <math.h>
#include "wx/wx.h"
#include "wx/region.h"
#include "wx/dc.h"
#include "KidsCindyFrame.h"
#include "KidsCindyCanvas.h"
#include "resource.h"
#include "wx/fontenum.h"
#include "wx/fontmap.h"
#include "wx/encconv.h"
#include "incident.h"

wxBitmap		*gs_bmpScreen;
wxBitmap		*gs_bmpBackGround;

#include "PtBmp.h"

PtBmp g_ball[5];
PtBmp g_star[5];
PtBmp g_cat[5];
PtBmp g_skeleton[5];
static wxBitmap		*gs_bmpbg_standard0;
static wxBitmap		*gs_bmpbg_standard1;
static wxBitmap		*gs_bmpbg_standard2;
static wxBitmap		*gs_bmpbg_cat;
static wxBitmap		*gs_bmpbg_star;
static wxBitmap		*gs_bmpbg_kseg;
static wxBitmap		*gs_bmpbg_cindy;
static wxBitmap		*gs_bmpbg_pastel;
static wxBitmap		*gs_bmpbg_skeleton;

	#include "ball_h0.xpm"		// ball_h0_xpm
	#include "ball_r0.xpm"		// ball_r0_xpm
	#include "ball_h1.xpm"		// ball_h1_xpm
	#include "ball_r1.xpm"		// ball_r1_xpm
	#include "ball_h2.xpm"		// ball_h2_xpm
	#include "ball_r2.xpm"		// ball_r2_xpm
	#include "ball_h3.xpm"		// ball_h3_xpm
	#include "ball_r3.xpm"		// ball_r3_xpm
	#include "ball_h4.xpm"		// ball_h4_xpm
	#include "ball_r4.xpm"		// ball_r4_xpm

	#include "cat_h0.xpm"		// cat_h0_xpm
	#include "cat_r0.xpm"		// cat_r0_xpm
	#include "cat_h1.xpm"		// cat_h1_xpm
	#include "cat_r1.xpm"		// cat_r1_xpm
	#include "cat_h2.xpm"		// cat_h2_xpm
	#include "cat_r2.xpm"		// cat_r2_xpm
	#include "cat_h3.xpm"		// cat_h3_xpm
	#include "cat_r3.xpm"		// cat_r3_xpm
	#include "cat_h4.xpm"		// cat_h4_xpm
	#include "cat_r4.xpm"		// cat_r4_xpm

	#include "star_h0.xpm"		// star_h0_xpm
	#include "star_r0.xpm"		// star_r0_xpm
	#include "star_h1.xpm"		// star_h0_xpm
	#include "star_r1.xpm"		// star_r0_xpm
	#include "star_h2.xpm"		// star_h0_xpm
	#include "star_r2.xpm"		// star_r0_xpm
	#include "star_h3.xpm"		// star_h0_xpm
	#include "star_r3.xpm"		// star_r0_xpm
	#include "star_h4.xpm"		// star_h0_xpm
	#include "star_r4.xpm"		// star_r0_xpm

	#include "skeleton.xpm"				// skeleton_xpm
	#include "skeleton_mask.xpm"		// skeleton_mask_xpm
	#include "skeleton_r.xpm"			// skeleton_r_xpm
	#include "skeleton_rmask.xpm"		// skeleton_rmask_xpm
	#include "BkCat.xpm"		// bkcat_xpm
	#include "BkCINDY.xpm"		// bkcindy_xpm
	#include "BkKSEG.xpm"		// bkkseg_xpm
	#include "BkPASTEL.xpm"		// bkpastel_xpm
	#include "BkStandard0.xpm"	// bkstandard0_xpm
	#include "BkStandard1.xpm"	// bkstandard0_xpm
	#include "BkStandard2.xpm"	// bkstandard0_xpm
	#include "BkStar.xpm"		// bkstar_xpm
	#include "BkSkeleton.xpm"		// bkskeleton_xpm

double abs(double a)
{
	return (a>0)? a:-a;
}


void MyCanvas::OnPaint(wxPaintEvent &WXUNUSED(event))
{
	wxPaintDC dc(this);
	PrepareDC(dc);
	m_owner->PrepareDC(dc);
	g_memdc.SelectObject(*gs_bmpScreen);
	g_memBGdc.SelectObject(*gs_bmpBackGround);
	if(!BGbmp){
		DrawBackGround(&g_memBGdc);
		BGbmp=true;
	}
	g_memdc.Blit(0,0,windowwidth,windowheight,&g_memBGdc,0,0);
	OnDraw(&g_memdc);
	dc.Blit(0,0,windowwidth,windowheight,&g_memdc,0,0);
	//wxStartTimer();
	//do {;
	//} while (wxGetElapsedTime(false)<50);
	//dc.Blit(0,0,windowwidth,windowheight,&g_memBGdc,0,0);
	//OnDraw((wxMemoryDC*)&dc);
	redraw=false;
}


bool LoadImages()
{
	gs_bmpScreen = new wxBitmap(1600,900);
	gs_bmpBackGround = new wxBitmap(1600,900);

	g_ball[0]._regular = new wxBitmap(ball_r0_xpm);
	g_ball[0]._regular_mask = new wxBitmap(ball_r0_xpm);
	g_ball[0]._mask_r=new wxMask(*(g_ball[0]._regular_mask),*wxBLACK);
	g_ball[0]._regular->SetMask(g_ball[0]._mask_r);
	g_ball[0]._hilighted = new wxBitmap(ball_h0_xpm);
	g_ball[0]._hilighted_mask = new wxBitmap(ball_h0_xpm);
	g_ball[0]._mask_h=new wxMask(*(g_ball[0]._hilighted_mask),*wxBLACK);
	g_ball[0]._hilighted->SetMask(g_ball[0]._mask_h);
	g_ball[1]._regular = new wxBitmap(ball_r1_xpm);
	g_ball[1]._regular_mask = new wxBitmap(ball_r1_xpm);
	g_ball[1]._mask_r=new wxMask(*(g_ball[1]._regular_mask),*wxBLACK);
	g_ball[1]._regular->SetMask(g_ball[1]._mask_r);
	g_ball[1]._hilighted = new wxBitmap(ball_h1_xpm);
	g_ball[1]._hilighted_mask = new wxBitmap(ball_h1_xpm);
	g_ball[1]._mask_h=new wxMask(*(g_ball[1]._hilighted_mask),*wxBLACK);
	g_ball[1]._hilighted->SetMask(g_ball[1]._mask_h);
	g_ball[2]._regular = new wxBitmap(ball_r2_xpm);
	g_ball[2]._regular_mask = new wxBitmap(ball_r2_xpm);
	g_ball[2]._mask_r=new wxMask(*(g_ball[2]._regular_mask),*wxBLACK);
	g_ball[2]._regular->SetMask(g_ball[2]._mask_r);
	g_ball[2]._hilighted = new wxBitmap(ball_h2_xpm);
	g_ball[2]._hilighted_mask = new wxBitmap(ball_h2_xpm);
	g_ball[2]._mask_h=new wxMask(*(g_ball[2]._hilighted_mask),*wxBLACK);
	g_ball[2]._hilighted->SetMask(g_ball[2]._mask_h);
	g_ball[3]._regular = new wxBitmap(ball_r3_xpm);
	g_ball[3]._regular_mask = new wxBitmap(ball_r3_xpm);
	g_ball[3]._mask_r=new wxMask(*(g_ball[3]._regular_mask),*wxBLACK);
	g_ball[3]._regular->SetMask(g_ball[3]._mask_r);
	g_ball[3]._hilighted = new wxBitmap(ball_h3_xpm);
	g_ball[3]._hilighted_mask = new wxBitmap(ball_h3_xpm);
	g_ball[3]._mask_h=new wxMask(*(g_ball[3]._hilighted_mask),*wxBLACK);
	g_ball[3]._hilighted->SetMask(g_ball[3]._mask_h);
	g_ball[4]._regular = new wxBitmap(ball_r4_xpm);
	g_ball[4]._regular_mask = new wxBitmap(ball_r4_xpm);
	g_ball[4]._mask_r=new wxMask(*(g_ball[4]._regular_mask),*wxBLACK);
	g_ball[4]._regular->SetMask(g_ball[4]._mask_r);
	g_ball[4]._hilighted = new wxBitmap(ball_h4_xpm);
	g_ball[4]._hilighted_mask = new wxBitmap(ball_h4_xpm);
	g_ball[4]._mask_h=new wxMask(*(g_ball[4]._hilighted_mask),*wxBLACK);
	g_ball[4]._hilighted->SetMask(g_ball[4]._mask_h);

	g_cat[0]._regular = new wxBitmap(cat_r0_xpm);
	g_cat[0]._regular_mask = new wxBitmap(cat_r0_xpm);
	g_cat[0]._mask_r = new wxMask(*(g_cat[0]._regular_mask),*wxWHITE);
	g_cat[0]._regular->SetMask(g_cat[0]._mask_r);
	g_cat[0]._hilighted = new wxBitmap(cat_h0_xpm);
	g_cat[0]._hilighted_mask = new wxBitmap(cat_h0_xpm);
	g_cat[0]._mask_h = new wxMask(*(g_cat[0]._hilighted_mask),*wxWHITE);
	g_cat[0]._hilighted->SetMask(g_cat[0]._mask_h);
	g_cat[1]._regular = new wxBitmap(cat_r1_xpm);
	g_cat[1]._regular_mask = new wxBitmap(cat_r1_xpm);
	g_cat[1]._mask_r = new wxMask(*(g_cat[0]._regular_mask),*wxWHITE);
	g_cat[1]._regular->SetMask(g_cat[0]._mask_r);
	g_cat[1]._hilighted = new wxBitmap(cat_h1_xpm);
	g_cat[1]._hilighted_mask = new wxBitmap(cat_h1_xpm);
	g_cat[1]._mask_h = new wxMask(*(g_cat[0]._hilighted_mask),*wxWHITE);
	g_cat[1]._hilighted->SetMask(g_cat[0]._mask_h);
	g_cat[2]._regular = new wxBitmap(cat_r2_xpm);
	g_cat[2]._regular_mask = new wxBitmap(cat_r2_xpm);
	g_cat[2]._mask_r = new wxMask(*(g_cat[0]._regular_mask),*wxWHITE);
	g_cat[2]._regular->SetMask(g_cat[0]._mask_r);
	g_cat[2]._hilighted = new wxBitmap(cat_h2_xpm);
	g_cat[2]._hilighted_mask = new wxBitmap(cat_h2_xpm);
	g_cat[2]._mask_h = new wxMask(*(g_cat[0]._hilighted_mask),*wxWHITE);
	g_cat[2]._hilighted->SetMask(g_cat[0]._mask_h);
	g_cat[3]._regular = new wxBitmap(cat_r3_xpm);
	g_cat[3]._regular_mask = new wxBitmap(cat_r3_xpm);
	g_cat[3]._mask_r = new wxMask(*(g_cat[0]._regular_mask),*wxWHITE);
	g_cat[3]._regular->SetMask(g_cat[0]._mask_r);
	g_cat[3]._hilighted = new wxBitmap(cat_h3_xpm);
	g_cat[3]._hilighted_mask = new wxBitmap(cat_h3_xpm);
	g_cat[3]._mask_h = new wxMask(*(g_cat[0]._hilighted_mask),*wxWHITE);
	g_cat[3]._hilighted->SetMask(g_cat[0]._mask_h);
	g_cat[4]._regular = new wxBitmap(cat_r4_xpm);
	g_cat[4]._regular_mask = new wxBitmap(cat_r4_xpm);
	g_cat[4]._mask_r = new wxMask(*(g_cat[0]._regular_mask),*wxWHITE);
	g_cat[4]._regular->SetMask(g_cat[0]._mask_r);
	g_cat[4]._hilighted = new wxBitmap(cat_h4_xpm);
	g_cat[4]._hilighted_mask = new wxBitmap(cat_h4_xpm);
	g_cat[4]._mask_h = new wxMask(*(g_cat[0]._hilighted_mask),*wxWHITE);
	g_cat[4]._hilighted->SetMask(g_cat[0]._mask_h);

	g_star[0]._regular = new wxBitmap(star_r0_xpm);
	g_star[0]._regular_mask = new wxBitmap(star_r0_xpm);
	g_star[0]._mask_r = new wxMask(*(g_star[0]._regular_mask),*wxBLACK);
	g_star[0]._regular->SetMask(g_star[0]._mask_r);
	g_star[0]._hilighted = new wxBitmap(star_h0_xpm);
	g_star[0]._hilighted_mask = new wxBitmap(star_h0_xpm); 
	g_star[0]._mask_h = new wxMask(*(g_star[0]._hilighted_mask),*wxBLACK);
	g_star[0]._hilighted->SetMask(g_star[0]._mask_h);
	g_star[1]._regular = new wxBitmap(star_r1_xpm);
	g_star[1]._regular_mask = new wxBitmap(star_r1_xpm);
	g_star[1]._mask_r = new wxMask(*(g_star[1]._regular_mask),*wxBLACK);
	g_star[1]._regular->SetMask(g_star[1]._mask_r);
	g_star[1]._hilighted = new wxBitmap(star_h1_xpm);
	g_star[1]._hilighted_mask = new wxBitmap(star_h1_xpm); 
	g_star[1]._mask_h = new wxMask(*(g_star[1]._hilighted_mask),*wxBLACK);
	g_star[1]._hilighted->SetMask(g_star[1]._mask_h);
	g_star[2]._regular = new wxBitmap(star_r2_xpm);
	g_star[2]._regular_mask = new wxBitmap(star_r2_xpm);
	g_star[2]._mask_r = new wxMask(*(g_star[2]._regular_mask),*wxBLACK);
	g_star[2]._regular->SetMask(g_star[2]._mask_r);
	g_star[2]._hilighted = new wxBitmap(star_h2_xpm);
	g_star[2]._hilighted_mask = new wxBitmap(star_h2_xpm); 
	g_star[2]._mask_h = new wxMask(*(g_star[2]._hilighted_mask),*wxBLACK);
	g_star[2]._hilighted->SetMask(g_star[2]._mask_h);
	g_star[3]._regular = new wxBitmap(star_r3_xpm);
	g_star[3]._regular_mask = new wxBitmap(star_r3_xpm);
	g_star[3]._mask_r = new wxMask(*(g_star[3]._regular_mask),*wxBLACK);
	g_star[3]._regular->SetMask(g_star[3]._mask_r);
	g_star[3]._hilighted = new wxBitmap(star_h3_xpm);
	g_star[3]._hilighted_mask = new wxBitmap(star_h3_xpm); 
	g_star[3]._mask_h = new wxMask(*(g_star[3]._hilighted_mask),*wxBLACK);
	g_star[3]._hilighted->SetMask(g_star[3]._mask_h);
	g_star[4]._regular = new wxBitmap(star_r4_xpm);
	g_star[4]._regular_mask = new wxBitmap(star_r4_xpm);
	g_star[4]._mask_r = new wxMask(*(g_star[4]._regular_mask),*wxBLACK);
	g_star[4]._regular->SetMask(g_star[4]._mask_r);
	g_star[4]._hilighted = new wxBitmap(star_h4_xpm);
	g_star[4]._hilighted_mask = new wxBitmap(star_h4_xpm); 
	g_star[4]._mask_h = new wxMask(*(g_star[4]._hilighted_mask),*wxBLACK);
	g_star[4]._hilighted->SetMask(g_star[4]._mask_h);

	g_skeleton[0]._regular = new wxBitmap(skeleton_xpm);
	g_skeleton[0]._regular_mask = new wxBitmap(skeleton_mask_xpm);
	g_skeleton[0]._mask_r=new wxMask(*(g_skeleton[0]._regular_mask),*wxWHITE);
	g_skeleton[0]._regular->SetMask(g_skeleton[0]._mask_r);
	g_skeleton[0]._hilighted = new wxBitmap(skeleton_r_xpm);
	g_skeleton[0]._hilighted_mask = new wxBitmap(skeleton_rmask_xpm); 
	g_skeleton[0]._mask_h = new wxMask(*(g_skeleton[0]._hilighted_mask),*wxWHITE);
	g_skeleton[0]._hilighted->SetMask(g_skeleton[0]._mask_h);
	g_skeleton[1]._regular = new wxBitmap(skeleton_xpm);
	g_skeleton[1]._regular_mask = new wxBitmap(skeleton_mask_xpm);
	g_skeleton[1]._mask_r=new wxMask(*(g_skeleton[0]._regular_mask),*wxWHITE);
	g_skeleton[1]._regular->SetMask(g_skeleton[0]._mask_r);
	g_skeleton[1]._hilighted = new wxBitmap(skeleton_r_xpm);
	g_skeleton[1]._hilighted_mask = new wxBitmap(skeleton_rmask_xpm); 
	g_skeleton[1]._mask_h = new wxMask(*(g_skeleton[0]._hilighted_mask),*wxWHITE);
	g_skeleton[1]._hilighted->SetMask(g_skeleton[0]._mask_h);
	g_skeleton[2]._regular = new wxBitmap(skeleton_xpm);
	g_skeleton[2]._regular_mask = new wxBitmap(skeleton_mask_xpm);
	g_skeleton[2]._mask_r=new wxMask(*(g_skeleton[0]._regular_mask),*wxWHITE);
	g_skeleton[2]._regular->SetMask(g_skeleton[0]._mask_r);
	g_skeleton[2]._hilighted = new wxBitmap(skeleton_r_xpm);
	g_skeleton[2]._hilighted_mask = new wxBitmap(skeleton_rmask_xpm); 
	g_skeleton[2]._mask_h = new wxMask(*(g_skeleton[0]._hilighted_mask),*wxWHITE);
	g_skeleton[2]._hilighted->SetMask(g_skeleton[0]._mask_h);
	g_skeleton[3]._regular = new wxBitmap(skeleton_xpm);
	g_skeleton[3]._regular_mask = new wxBitmap(skeleton_mask_xpm);
	g_skeleton[3]._mask_r=new wxMask(*(g_skeleton[0]._regular_mask),*wxWHITE);
	g_skeleton[3]._regular->SetMask(g_skeleton[0]._mask_r);
	g_skeleton[3]._hilighted = new wxBitmap(skeleton_r_xpm);
	g_skeleton[3]._hilighted_mask = new wxBitmap(skeleton_rmask_xpm); 
	g_skeleton[3]._mask_h = new wxMask(*(g_skeleton[0]._hilighted_mask),*wxWHITE);
	g_skeleton[3]._hilighted->SetMask(g_skeleton[0]._mask_h);
	g_skeleton[4]._regular = new wxBitmap(skeleton_xpm);
	g_skeleton[4]._regular_mask = new wxBitmap(skeleton_mask_xpm);
	g_skeleton[4]._mask_r=new wxMask(*(g_skeleton[0]._regular_mask),*wxWHITE);
	g_skeleton[4]._regular->SetMask(g_skeleton[0]._mask_r);
	g_skeleton[4]._hilighted = new wxBitmap(skeleton_r_xpm);
	g_skeleton[4]._hilighted_mask = new wxBitmap(skeleton_rmask_xpm); 
	g_skeleton[4]._mask_h = new wxMask(*(g_skeleton[0]._hilighted_mask),*wxWHITE);
	g_skeleton[4]._hilighted->SetMask(g_skeleton[0]._mask_h);

	gs_bmpbg_standard0 = new wxBitmap(bkstandard0_xpm);
	gs_bmpbg_standard1 = new wxBitmap(bkstandard1_xpm);
	gs_bmpbg_standard2 = new wxBitmap(bkstandard2_xpm);
	gs_bmpbg_cat = new wxBitmap(bkcat_xpm);
	gs_bmpbg_star = new wxBitmap(bkstar_xpm);
	gs_bmpbg_kseg = new wxBitmap(bkkseg_xpm);
	gs_bmpbg_cindy = new wxBitmap(bkcindy_xpm);
	gs_bmpbg_pastel = new wxBitmap(bkpastel_xpm);
	gs_bmpbg_skeleton = new wxBitmap(bkskeleton_xpm);

	return true;
}
void MyCanvas::OnDraw(wxMemoryDC* pDC)
{
	if(AxisOn){
		DrawAxis(pDC);
	}
//  draw clones
	if(DocMode==MODE_MOVE && CloneOnOff && m_move_dragging){
		DrawLines(lns3,pDC);
		DrawLines(lns2,pDC);
		DrawLines(lns1,pDC);
		DrawCircles(cis3,pDC); 
		DrawCircles(cis2,pDC); 
		DrawCircles(cis1,pDC); 
		DrawPoints(pts3,pDC); 
		DrawPoints(pts2,pDC); 
		DrawPoints(pts1,pDC); 
	}
	
	if(DocMode==MODE_COMPASS){
		DrawCompassCircle(pDC);
	}
	if(SMode && anim_wait==false){
		Animnext();
	}

	DrawLines(lns,pDC);//  draw lines
	DrawCircles(cis,pDC); //  draw circles
	DrawCurves(curves,pDC); //  draw curves
	DrawPoints(cns,pDC); //  draw points
	DrawTexts(texts,pDC); //  draw texts

	//  while draggin, draw the current point
	if(m_point_dragging){
		switch(DocMode){
		case MODE_SINGLE_ADD:
			DrawOnePoint(cursorpt,pDC);
			break;
		case MODE_MULTI_LINE:
			DrawOnePoint(cursorpt,pDC);
			DrawOneLine(cursorln,pDC);
			break;
		case MODE_PARALLEL:
			DrawOnePoint(cursorpt,pDC);
			DrawOneLine(cursorln,pDC);
			break;
		case MODE_PERP:
			DrawOnePoint(cursorpt,pDC);
			DrawOneLine(cursorln,pDC);
			break;
		case MODE_MID:
			DrawOnePoint(cursorpt,pDC);
			DrawOnePoint(cursorpt2,pDC);
			break;
		case MODE_MULTI_CIRCLE:
			DrawOnePoint(cursorpt,pDC);
			DrawOneCircle(cursorci,pDC);
		}
	}
	wxString str;
	str.Printf( wxT("Sheet: %d/%d"), currentSheet+1,NOMySheet );
	m_owner->SetStatusText( str );

}

void MyCanvas::DrawBackGround(wxMemoryDC *pDC)
{
	int i,j,col,row;
	pDC->SelectObject(*gs_bmpBackGround);
	row=(windowwidth/256)+1;
	col=(windowheight/192)+1;
	for(i=0;i<row;i++)for(j=0;j<col;j++){
		switch(BgMode){
		case BG_STANDARD:
			switch(bgdsn){
			case 0: pDC->DrawBitmap(*gs_bmpbg_standard0,i*256,j*192,false); break;
			case 1: pDC->DrawBitmap(*gs_bmpbg_standard1,i*256,j*192,false); break;
			case 2: pDC->DrawBitmap(*gs_bmpbg_standard2,i*256,j*192,false); break;
			}
			break;
		case BG_CAT:
			pDC->DrawBitmap(*gs_bmpbg_cat,i*256,j*192,false);
			break;
		case BG_STAR:
			pDC->DrawBitmap(*gs_bmpbg_star,i*256,j*192,false);
			break;
		case BG_KSEG:
			pDC->DrawBitmap(*gs_bmpbg_kseg,i*256,j*192,false);
			break;
		case BG_CINDY:
			pDC->DrawBitmap(*gs_bmpbg_cindy,i*256,j*192,false);
			break;
		case BG_PASTEL:
			pDC->DrawBitmap(*gs_bmpbg_pastel,i*256,j*192,false);
			break;
		case BG_SKELETON:
			pDC->DrawBitmap(*gs_bmpbg_skeleton,i*256,j*192,false);
			break;
		}
	}
}

void MyCanvas::DrawAxis(wxMemoryDC *pDC)
{
	double dispx0,dispy0,dispx1,dispy1;
	double i;
	if(boxleft<0.0 && boxright>0.0){
		pDC->SetPen(AxisPen);
		dispx0=(0.0-geomcx)/geomperdot+centerx;
		dispy0=-(boxtop-geomcy)/geomperdot+centery;
		dispx1=(0.0-geomcx)/geomperdot+centerx;
		dispy1=-(boxbottom-geomcy)/geomperdot+centery;
		pDC->DrawLine((int)floor(dispx0),(int)floor(dispy0),(int)floor(dispx1),(int)floor(dispy1));
		pDC->SetPen(AxisMeshPen);
		for(i=floor(boxbottom)+1.0;i<floor(boxtop)+1.0;i+=1.0){
			dispx0=(-0.05-geomcx)/geomperdot+centerx;
			dispy0=-(i-geomcy)/geomperdot+centery;
			dispx1=(+0.05-geomcx)/geomperdot+centerx;
			dispy1=-(i-geomcy)/geomperdot+centery;
			pDC->DrawLine((int)floor(dispx0),(int)floor(dispy0),(int)floor(dispx1),(int)floor(dispy1));
		}
	}
	if(boxtop>0.0 && boxbottom<0.0){
		pDC->SetPen(AxisPen);
		dispx0=(boxleft-geomcx)/geomperdot+centerx;
		dispy0=-(0.0-geomcy)/geomperdot+centery;
		dispx1=(boxright-geomcx)/geomperdot+centerx;
		dispy1=-(0.0-geomcy)/geomperdot+centery;
		pDC->DrawLine((int)floor(dispx0),(int)floor(dispy0),(int)floor(dispx1),(int)floor(dispy1));
		pDC->SetPen(AxisMeshPen);
		for(i=floor(boxleft)+1.0;i<floor(boxright)+1.0;i+=1.0){
			dispx0=(i-geomcx)/geomperdot+centerx;
			dispy0=-(-0.05-geomcy)/geomperdot+centery;
			dispx1=(i-geomcx)/geomperdot+centerx;
			dispy1=-(+0.05-geomcy)/geomperdot+centery;
			pDC->DrawLine((int)floor(dispx0),(int)floor(dispy0),(int)floor(dispx1),(int)floor(dispy1));
		}
	}
}

bool MyCanvas::DrawOnePoint(GPoint* pt,wxMemoryDC* pDC)
{
	if(pt==0){
		return false;
	}

	if(pt->zz.zerop()){
		return false;
	}
	if(!pt->xz().realp() || !pt->yz().realp() || pt->invisible){
		return false;
	}
	double geomx=pt->xz().real();
	double geomy=pt->yz().real();
	int dispx=centerx+(int)floor((geomx-geomcx)/geomperdot)+pt->offsetx;
	int dispy=centery-(int)floor((geomy-geomcy)/geomperdot)+pt->offsety;
	int r_bmpsize=0,r_bmphsize=0;
	int h_bmpsize=0,h_bmphsize=0;
	wxBitmap *mybmp_r=NULL,*mybmp_h=NULL;
	PtBmp* myptbmp=NULL;
	unsigned char r,g,b;
	switch(PtMode){
	case PT_STANDARD:
		myptbmp=g_ball;
		break;
	case PT_CAT:
		myptbmp=g_cat;
		break;
	case PT_STAR:
		myptbmp=g_star;
		break;
	case PT_SKELETON:
		myptbmp=g_skeleton;
		break;
	}
	switch(PtMode){
	case PT_STANDARD:
	case PT_CAT:
	case PT_STAR:
	case PT_SKELETON:
		mybmp_r=myptbmp[pt->ptbmp]._regular;
		mybmp_h=myptbmp[pt->ptbmp]._hilighted;
		r_bmpsize=mybmp_r->GetHeight();r_bmphsize=r_bmpsize/2;
		h_bmpsize=mybmp_h->GetHeight();h_bmphsize=h_bmpsize/2;
		pt->phase_max=mybmp_h->GetWidth()/mybmp_h->GetHeight();
		break;
	}
	if(relRect.Inside(dispx,dispy)){
		switch(PtMode){
		case PT_STANDARD:
		case PT_CAT:
		case PT_STAR:
		case PT_SKELETON:
			if(pt->hilighted){
				if(pt->hilightphase < pt->phase_max){
					pDC->DrawBitmap(mybmp_h->GetSubBitmap(wxRect(h_bmpsize* pt->hilightphase,0,h_bmpsize,h_bmpsize)),dispx-h_bmphsize,dispy-h_bmphsize,true);
				}
				pt->hilightphase ++;
				if(pt->hilightphase >= pt->phase_max){
					pt->hilightphase=0;
				}
			}
			else if(pt->expand>1.0){
				pDC->DrawBitmap(mybmp_h->GetSubBitmap(wxRect(h_bmpsize*((int)floor((pt->expand-1.0)/0.2)),0,h_bmpsize,h_bmpsize)),dispx-h_bmphsize,dispy-h_bmphsize,true);
			}
			else if(pt->vanishing<4){
				pDC->DrawBitmap(mybmp_r->GetSubBitmap(wxRect(r_bmpsize* pt->vanishing,0,r_bmpsize,r_bmpsize)),dispx-r_bmphsize,dispy-r_bmphsize,true);
			}
			break;
		case PT_KSEG:
		case PT_CINDY:
		case PT_PASTEL:
			if(pt->hilighted){
				pDC->SetBrush(wxBrush(wxColour(HilColR,HilColG,HilColB),wxSOLID));
				pDC->SetPen(wxPen(wxColour(HilColR,HilColG,HilColB),1,wxSOLID));
				pDC->DrawCircle(dispx,dispy,HilRad);
				pDC->SetBrush(wxBrush(wxColour(OutColR,OutColG,OutColB),wxSOLID));
				pDC->SetPen(wxPen(wxColour(OutColR,OutColG,OutColB),1,wxSOLID));
				pDC->DrawCircle(dispx,dispy,OutRad);
				pDC->SetBrush(wxBrush(wxColour(InColR[pt->ptbmp],InColG[pt->ptbmp],InColB[pt->ptbmp]),wxSOLID));
				pDC->SetPen(wxPen(wxColour(InColR[pt->ptbmp],InColG[pt->ptbmp],InColB[pt->ptbmp]),1,wxSOLID));
				pDC->DrawCircle(dispx,dispy,InRad);
			}
			else if(pt->vanishing<4){
				r=OutColR+pt->vanishing*(BgR[BackgroundMode-BG_1]-OutColR)/4;
				g=OutColG+pt->vanishing*(BgG[BackgroundMode-BG_1]-OutColG)/4;
				b=OutColB+pt->vanishing*(BgB[BackgroundMode-BG_1]-OutColB)/4;
				pDC->SetBrush(wxBrush(wxColour(r,g,b),wxSOLID));
				pDC->SetPen(wxPen(wxColour(r,g,b),1,wxSOLID));
				pDC->DrawCircle(dispx,dispy,(int)floor(OutRad*pt->expand));
				r=InColR[pt->ptbmp]+pt->vanishing*(BgR[BackgroundMode-BG_1]-InColR[pt->ptbmp])/4;
				g=InColG[pt->ptbmp]+pt->vanishing*(BgG[BackgroundMode-BG_1]-InColG[pt->ptbmp])/4;
				b=InColB[pt->ptbmp]+pt->vanishing*(BgB[BackgroundMode-BG_1]-InColB[pt->ptbmp])/4;
				pDC->SetBrush(wxBrush(wxColour(r,g,b),wxSOLID));
				pDC->SetPen(wxPen(wxColour(r,g,b),1,wxSOLID));
				pDC->DrawCircle(dispx,dispy,(int)floor(InRad*pt->expand));
			}
			break;
		}
		pDC->SetFont(wxFont(pt->_fontsize, wxFONTFAMILY_DEFAULT, wxFONTSTYLE_NORMAL, wxFONTWEIGHT_NORMAL, false, wxT(""),  wxFONTENCODING_DEFAULT));
		if(pt->vanishing<4){
			wxString str((char*)pt->_name.c_str(),*wxConvCurrent);
			pDC->SetTextForeground(wxColour(TextColR,TextColG,TextColB));
			pDC->DrawText(str,dispx+(int)floor((10+pt->_fontsize)*cos(pt->_name_theta))-(pt->_fontsize/2),
				dispy-(int)floor((10+pt->_fontsize)*sin(pt->_name_theta))-(pt->_fontsize));
		}
	}
	return false;
}

bool MyCanvas::DrawPoints(GConst* cnp,wxMemoryDC* pDC)
{
	if(cnp==0){
		return true;
	}
	if(cnp->Output_Type()==OUTPUT_POINT){
		DrawOnePoint(cnp->POutput,pDC);
	}
	if(cnp->next!=0){
		DrawPoints(cnp->next,pDC);
	}
	return false;
}

bool MyCanvas::DrawPoints(GPoint* p,wxMemoryDC* pDC)
{
	if(p==0){
		return true;
	}
	DrawOnePoint(p,pDC);
	if(p->next!=0){
		DrawPoints(p->next,pDC);
	}
	return false;
}

int min(int a,int b)
{
	if(a<b) return a;
	else return b;
}

double min(double a,double b);

void FindLineends(GIncident* ic,GIncident**mn,GIncident**mx)
{
	if(ic==NULL){
		return;
	}
	if(*mn!=NULL && (*mn)->_icpara.imag()==0.0 && (*mn)->_icpara.real()>ic->_icpara.real()){
		*mn=ic;
	}
	else if(*mn==NULL){
		*mn=ic;
	}
	if(*mx!=NULL && (*mn)->_icpara.imag()==0.0 && (*mx)->_icpara.real() < ic->_icpara.real()){
		*mx=ic;
	}
	else if(*mx==NULL){
		*mx=ic;
	}
	FindLineends(ic->_icnext,mn,mx);
}

bool MyCanvas::GetGeomXY(GLine* p, double* dx0, double* dy0, double* dx1, double* dy1)
{	
	double rx,ry,rz;
	if(p->realp(&rx,&ry,&rz)==false || p->invisible){
		return false;
	}
	double geomx[2],geomy[2];
	GIncident* mn,*mx;
	int geomcount=0;
	double tt;
	if(ry!=0.0){
		tt=-(rz+rx*boxleft)/ry;
		if(tt<boxtop  && tt>boxbottom){
			geomx[geomcount]=boxleft;
			geomy[geomcount]=tt;
			geomcount++;
		}
	}
	if(ry!=0.0){
		tt=-(rz+rx*boxright)/ry;
		if(tt<boxtop  && tt>boxbottom){
			geomx[geomcount]=boxright;
			geomy[geomcount]=tt;
			geomcount++;
		}
	}
	if(rx!=0.0){
		tt=-(rz+ry*boxtop)/rx;
		if(tt>boxleft && tt<boxright){
			geomx[geomcount]=tt;
			geomy[geomcount]=boxtop;
			geomcount++;
		}
	}
	if(rx!=0.0){
		tt=-(rz+ry*boxbottom)/rx;
		if(tt>boxleft && tt<boxright){
			geomx[geomcount]=tt;
			geomy[geomcount]=boxbottom;
			geomcount++;
		}
	}
	if(geomcount<2){
		return false;
	}
	double geomx1=0,geomy1=0,geomx2=0,geomy2=0;
	if(p->clipping && p->NOics<0){
		geomx1=p->afterimage_x1;
		geomy1=p->afterimage_y1;
		geomx2=p->afterimage_x2;
		geomy2=p->afterimage_y2;
	}
	else if(p->clipping && p->NOics>=2){
		double hx1,hy1,hx2,hy2;
		double tt1,tt2;
		mn=mx=NULL;
		ResetLineIcPara(p);
		FindLineends(p->ics,&mn,&mx);
		if(mn==mx){
			geomx1=geomx[0];
			geomy1=geomy[0];
			geomx2=geomx[1];
			geomy2=geomy[1];
		}
		else {
			hx1=mn->_icpt->xz().real();
			hy1=mn->_icpt->yz().real();
			hx2=mx->_icpt->xz().real();
			hy2=mx->_icpt->yz().real();
			if(hx1!=hx2){
				tt1=(geomx[0]-hx1)/(hx2-hx1);
				tt2=(geomx[1]-hx1)/(hx2-hx1);
			}
			else {
				tt1=(geomy[0]-hy1)/(hy2-hy1);
				tt2=(geomy[1]-hy1)/(hy2-hy1);
			}
			if(tt1<0.0){
				if(tt2<0.0){
					return false;
				}
				else if(tt2<1.0){
					geomx1=hx1;
					geomy1=hy1;
					geomx2=geomx[1];
					geomy2=geomy[1];
				}
				else {
					geomx1=hx1;
					geomy1=hy1;
					geomx2=hx2;
					geomy2=hy2;
				}
			}
			else if(tt1<1.0){
				if(tt2<0.0){
					geomx1=geomx[0];
					geomy1=geomy[0];
					geomx2=hx1;
					geomy2=hy1;
				}
				else if(tt2<1.0){
					geomx1=geomx[0];
					geomy1=geomy[0];
					geomx2=geomx[1];
					geomy2=geomy[1];
				}
				else {
					geomx1=geomx[0];
					geomy1=geomy[0];
					geomx2=hx2;
					geomy2=hy2;
				}
			}
			else {
				if(tt2<0.0){
					geomx1=hx1;
					geomy1=hy1;
					geomx2=hx2;
					geomy2=hy2;
				}
				else if(tt2<1.0){
					geomx1=geomx[1];
					geomy1=geomy[1];
					geomx2=hx2;
					geomy2=hy2;
				}
				else {
					return false;
				}
			}
		}
		p->afterimage_x1=geomx1;
		p->afterimage_y1=geomy1;
		p->afterimage_x2=geomx2;
		p->afterimage_y2=geomy2;
	}
	else {
		geomx1=geomx[0];
		geomy1=geomy[0];
		geomx2=geomx[1];
		geomy2=geomy[1];
	}
	double dispx0,dispx1,dispy0,dispy1;
	if(geomx1<=geomx2){
		dispx0=(geomx1-geomcx)/geomperdot+centerx;
		dispx1=(geomx2-geomcx)/geomperdot+centerx;
		dispy0=-(geomy1-geomcy)/geomperdot+centery;
		dispy1=-(geomy2-geomcy)/geomperdot+centery;
	}
	else {
		dispx0=(geomx2-geomcx)/geomperdot+centerx;
		dispx1=(geomx1-geomcx)/geomperdot+centerx;
		dispy0=-(geomy2-geomcy)/geomperdot+centery;
		dispy1=-(geomy1-geomcy)/geomperdot+centery;
	}
	double theta=atan2(dispy1-dispy0,dispx1-dispx0);
	double linewidth = LnDesign[p->lndsn].LnRgn[0]._LineWidth;
	if(-0.5+relRect.GetLeft()<dispx0 && dispx0<0.5+relRect.GetLeft()){
		dispx0 -= (linewidth*abs(tan(theta))*cos(theta));
		dispy0 -= (linewidth*abs(tan(theta))*sin(theta));
	}
	else if(-0.5+relRect.GetTop()<dispy0 && dispy0<0.5+relRect.GetTop()){
		dispx0 -= (linewidth*cos(theta)/sin(theta)*cos(theta));
		dispy0 -= (linewidth*cos(theta));
	}
	else if(-0.5+relRect.GetBottom()<dispy0 && dispy0<0.5+relRect.GetBottom()){
		dispx0 += (linewidth*cos(theta)/sin(theta)*cos(theta));
		dispy0 += (linewidth*cos(theta));
	}
	if(-0.5+relRect.GetRight()<dispx1 && dispx1<0.5+relRect.GetRight()){
		dispx1 += (linewidth*abs(tan(theta))*cos(theta));
		dispy1 += (linewidth*abs(tan(theta))*sin(theta));
	}
	else if(-0.5+relRect.GetTop()<dispy1 && dispy1<0.5+relRect.GetTop()){
		dispx1 -= (linewidth*cos(theta)/sin(theta)*cos(theta));
		dispy1 -= (linewidth*cos(theta));
	}
	else if(-0.5+relRect.GetBottom()<dispy1 && dispy1<0.5+relRect.GetBottom()){
		dispx1 += (linewidth*cos(theta)/sin(theta)*cos(theta));
		dispy1 += (linewidth*cos(theta));
	}
	*dx0=dispx0;
	*dy0=dispy0;
	*dx1=dispx1;
	*dy1=dispy1;
	return true;
}

bool MyCanvas::DrawOneLine(GLine* p, wxMemoryDC* pDC)
{
	if(p==0){
		return false;
	}
	double dispx0,dispx1,dispy0,dispy1;
	if(GetGeomXY(p, &dispx0, &dispy0, &dispx1, &dispy1)==false){
		return false;
	}
	int i,j,k;
	unsigned char r,g,b;
	double linelength = LnDesign[p->lndsn].LnRgn[0]._LineLength;
	double theta=atan2(dispy1-dispy0,dispx1-dispx0);
	int loopend = 1+(int)floor(sqrt((dispx1-dispx0)*(dispx1-dispx0)+(dispy1-dispy0)*(dispy1-dispy0))/linelength);
	int lastseg = (int)floor(sqrt((dispx1-dispx0)*(dispx1-dispx0)+(dispy1-dispy0)*(dispy1-dispy0))-linelength*(loopend-1));
	wxPoint myP[20];
	int jstart=(p->hilighted)? 0:1;
 	for(i=0;i<loopend;i++){
		for(j=jstart;j<LnDesign[p->lndsn].NLnRgn;j++){
			if(LnDesign[p->lndsn].LnRgn[j]._LGTH==2){
				if(p->vanishing<4){
					r=LnDesign[p->lndsn].LnRgn[j]._R+p->vanishing*(BgR[BackgroundMode-BG_1] - LnDesign[p->lndsn].LnRgn[j]._R)/4;
					g=LnDesign[p->lndsn].LnRgn[j]._G+p->vanishing*(BgG[BackgroundMode-BG_1] - LnDesign[p->lndsn].LnRgn[j]._G)/4;
					b=LnDesign[p->lndsn].LnRgn[j]._B+p->vanishing*(BgB[BackgroundMode-BG_1] - LnDesign[p->lndsn].LnRgn[j]._B)/4;
					if(p->expand>1.0){
						pDC->SetPen(wxPen(wxColour(r,g,b),(int)floor((p->expand-1.0)/0.2+2.0),wxSOLID));
					}
					else{
						pDC->SetPen(wxPen(wxColour(r,g,b),2,wxSOLID));
					}
					pDC->DrawLine((int)floor(dispx0+p->offsetx),(int)floor(dispy0+p->offsety),(int)floor(dispx1+p->offsetx),(int)floor(dispy1+p->offsety));
				}
			}
			else {
				for(k=0;k<LnDesign[p->lndsn].LnRgn[j]._LGTH;k++){
					if(i<loopend-1){
						myP[k].x = (int)floor( dispx0 + cos(theta)*linelength*i 
							+ cos(theta)*LnDesign[p->lndsn].LnRgn[j]._PT[k].x - sin(theta)*LnDesign[p->lndsn].LnRgn[j]._PT[k].y*p->expand) ;
						myP[k].y = (int)floor( dispy0 + sin(theta)*linelength*i 
							+ sin(theta)*LnDesign[p->lndsn].LnRgn[j]._PT[k].x + cos(theta)*LnDesign[p->lndsn].LnRgn[j]._PT[k].y*p->expand) ;
					}
					else {
						myP[k].x = (int)floor( dispx0 + cos(theta)*linelength*i 
							+ cos(theta)*min(lastseg,LnDesign[p->lndsn].LnRgn[j]._PT[k].x) - sin(theta)*LnDesign[p->lndsn].LnRgn[j]._PT[k].y*p->expand) ;
						myP[k].y = (int)floor( dispy0 + sin(theta)*linelength*i 
							+ sin(theta)*min(lastseg,LnDesign[p->lndsn].LnRgn[j]._PT[k].x) + cos(theta)*LnDesign[p->lndsn].LnRgn[j]._PT[k].y*p->expand) ;
					}
				}
				if(p->vanishing<4){
					r=LnDesign[p->lndsn].LnRgn[j]._R+p->vanishing*(BgR[BackgroundMode-BG_1] - LnDesign[p->lndsn].LnRgn[j]._R)/4;
					g=LnDesign[p->lndsn].LnRgn[j]._G+p->vanishing*(BgG[BackgroundMode-BG_1] - LnDesign[p->lndsn].LnRgn[j]._G)/4;
					b=LnDesign[p->lndsn].LnRgn[j]._B+p->vanishing*(BgB[BackgroundMode-BG_1] - LnDesign[p->lndsn].LnRgn[j]._B)/4;
					pDC->SetPen(wxPen(wxColour(r,g,b),1,wxSOLID));
					pDC->SetBrush(wxBrush(wxColour(r,g,b),wxSOLID));
					pDC->DrawPolygon(LnDesign[p->lndsn].LnRgn[j]._LGTH,myP,p->offsetx,p->offsety,wxWINDING_RULE);
				}
			}
		}
	}
	return false;
}

bool MyCanvas::DrawLines(GLine* p, wxMemoryDC* pDC)
{
	if(p==0){
		return true;
	}
	DrawOneLine(p,pDC);
	if(p->next!=0){
		DrawLines(p->next,pDC);
	}
	return false;
}

bool MyCanvas::DrawOneCircle(GCircle* p, wxMemoryDC* pDC)
{
	if(p==0){
		return false;
	}
	if(!p->xx.realp() || !p->yy.realp() || !p->rr.realp() || p->invisible){
		return false;
	}
	int cx = centerx + (int)floor((p->xx.real() - geomcx) / geomperdot);
	int cy = centery - (int)floor((p->yy.real() - geomcy) / geomperdot);
	int cr = (int)floor(sqrt(p->rr.real()) / geomperdot );
	
	if(relRect.GetLeft() >cx+cr || relRect.GetRight() <cx-cr || relRect.GetTop() > cy+cr || relRect.GetBottom() < cy-cr){
		return false;
	}

	int j,k;
	double i;
	double linelength = LnDesign[p->lndsn].LnRgn[0]._LineLength;
	double step = linelength/cr;
	unsigned char r,g,b;
	//determine start and end
	double end1,end2;
	if(p->clipping && p->NOics>2){
		ResetCircleIcPara(p);
		end1=p->ics->_icpara.real();
		double mid=p->ics->_icnext->_icpara.real();
		end2=p->ics->_icnext->_icnext->_icpara.real();
		//printf("%s%s%s:",p->ics->_icpt->_name.c_str(),p->ics->_icnext->_icpt->_name.c_str(),p->ics->_icnext->_icnext->_icpt->_name.c_str());
		//printf("%lf,%lf,%lf\n",end1,mid,end2);
		double pp;
		if(end1>=mid && mid>=end2){
			pp=end1;end1=end2;end2=pp;
		}
		else if(end1>=end2 && end2>=mid){
			end2+=6.28;
		}
		else if(end2>=mid && mid>=end1){
			;
		}
		else if(end2>=end1 && end1>=mid){
			pp=end1;end1=end2;end2=pp+6.28;
		}
		else if(mid>=end1 && end1>=end2){
			end2+=6.28;
		}
		else if(mid>=end2 && end2>=end1){
			pp=end1;end1=end2;end2=pp+6.28;
		}
	}
	else {
		end1=0.0;
		end2=6.28;
	}
	wxPoint myP[20];
	double laststep=end2-end1-floor((end2-end1)/step)*step;
	int jstart=(p->hilighted)? 0:1;
	for(i=end1;i<end2;i+=step){
		for(j=jstart;j<LnDesign[p->lndsn].NLnRgn;j++){
			for(k=0;k<LnDesign[p->lndsn].LnRgn[j]._LGTH;k++){
				if(i<end2-step){
					myP[k].x = (int)floor( cx + p->offsetx + (cr+LnDesign[p->lndsn].LnRgn[j]._PT[k].y*p->expand)*cos(i + 1.0*LnDesign[p->lndsn].LnRgn[j]._PT[k].x/cr));
					myP[k].y = (int)floor( cy + p->offsety + (cr+LnDesign[p->lndsn].LnRgn[j]._PT[k].y*p->expand)*sin(i + 1.0*LnDesign[p->lndsn].LnRgn[j]._PT[k].x/cr));
				}
				else {
					myP[k].x = (int)floor( cx + p->offsetx + (cr+LnDesign[p->lndsn].LnRgn[j]._PT[k].y*p->expand)*cos(i + min(laststep,1.0*LnDesign[p->lndsn].LnRgn[j]._PT[k].x/cr)));
					myP[k].y = (int)floor( cy + p->offsety + (cr+LnDesign[p->lndsn].LnRgn[j]._PT[k].y*p->expand)*sin(i + min(laststep,1.0*LnDesign[p->lndsn].LnRgn[j]._PT[k].x/cr)));
				}
			}
			if(LnDesign[p->lndsn].LnRgn[j]._LGTH==2){
				if(p->vanishing<4){
					r=LnDesign[p->lndsn].LnRgn[j]._R+p->vanishing*(BgR[BackgroundMode-BG_1] - LnDesign[p->lndsn].LnRgn[j]._R)/4;
					g=LnDesign[p->lndsn].LnRgn[j]._G+p->vanishing*(BgG[BackgroundMode-BG_1] - LnDesign[p->lndsn].LnRgn[j]._G)/4;
					b=LnDesign[p->lndsn].LnRgn[j]._B+p->vanishing*(BgB[BackgroundMode-BG_1] - LnDesign[p->lndsn].LnRgn[j]._B)/4;
					if(p->expand>1.0){
						pDC->SetPen(wxPen(wxColour(r,g,b),(int)floor((p->expand-1.0)/0.2+2.0),wxSOLID));
					}
					else{
						pDC->SetPen(wxPen(wxColour(r,g,b),2,wxSOLID));
					}
					pDC->DrawLine(myP[0].x+ p->offsetx,myP[0].y+ p->offsety,myP[1].x+ p->offsetx,myP[1].y+ p->offsety);
				}
			}
			else {
				if(p->vanishing<4){
					r=LnDesign[p->lndsn].LnRgn[j]._R+p->vanishing*(BgR[BackgroundMode-BG_1] - LnDesign[p->lndsn].LnRgn[j]._R)/4;
					g=LnDesign[p->lndsn].LnRgn[j]._G+p->vanishing*(BgG[BackgroundMode-BG_1] - LnDesign[p->lndsn].LnRgn[j]._G)/4;
					b=LnDesign[p->lndsn].LnRgn[j]._B+p->vanishing*(BgB[BackgroundMode-BG_1] - LnDesign[p->lndsn].LnRgn[j]._B)/4;
					pDC->SetPen(wxPen(wxColour(r,g,b),1,wxSOLID));
					pDC->SetBrush(wxBrush(wxColour(r,g,b),wxSOLID));
					pDC->DrawPolygon(LnDesign[p->lndsn].LnRgn[j]._LGTH,myP,0,0,wxWINDING_RULE);
				}
			}
		}
	}
	return false;
}

bool MyCanvas::DrawCircles(GCircle* p, wxMemoryDC* pDC)
{
	if(p==0){
		return true;
	}
	DrawOneCircle(p,pDC);
	if(p->next!=0){
		DrawCircles(p->next,pDC);
	}
	return false;
}


bool MyCanvas::DrawOneCurve(GParaCurve* p, wxMemoryDC* pDC)
{
	if(p==0 || p->invisible){
		return false;
	}
	double theta,linelength;
	double linerate;
	double dispx0,dispx1,dispy0,dispy1;
	int jstart;
	if(p->hilighted){
		jstart=0;
	}
	else {
		jstart=1;
	}
	int i,j,k;
	bool good0,good1,good2,good3;
	unsigned char r,g,b;
	wxPoint myP[20];
	dispx1=(p->orbitx[p->orbit_len-1]-geomcx)/geomperdot+centerx;
	dispy1=-(p->orbity[p->orbit_len-1]-geomcy)/geomperdot+centery;
	good1= p->orbitx[p->orbit_len-1]>boxleft && p->orbitx[p->orbit_len-1]<boxright 
		&& - p->orbity[p->orbit_len-1]<boxtop && - p->orbity[p->orbit_len-1]>boxbottom;
	good3 = p->orbit_real[p->orbit_len-1];
	for(i=0;i<p->orbit_len;i++){
		dispx0 = dispx1;
		dispy0 = dispy1;
		good0 = good1;
		good2 = good3;
		dispx1 = (p->orbitx[i]-geomcx)/geomperdot+centerx;
		dispy1 = -(p->orbity[i]-geomcy)/geomperdot+centery;
		good1= p->orbitx[i]>boxleft && p->orbitx[i]<boxright 
			&& - p->orbity[i]<boxtop && - p->orbity[i]>boxbottom;
		good3= p->orbit_real[i];
		if((good0 || good1)/* && (good2 || good3) */){
			if(m_lbuttondown){
				pDC->DrawRectangle((int)floor(dispx1)-2,(int)floor(dispy1)-2,5,5);
			}
			else {
				theta=atan2(dispy1-dispy0,dispx1-dispx0);
				linelength = LnDesign[p->lndsn].LnRgn[0]._LineLength;
				linerate = sqrt((dispx0-dispx1)*(dispx0-dispx1)+(dispy0-dispy1)*(dispy0-dispy1))/linelength;
				if(linerate<3.0){
					for(j=jstart;j<LnDesign[p->lndsn].NLnRgn;j++){
						if(LnDesign[p->lndsn].LnRgn[j]._LGTH==2){
							if(p->vanishing<4){
								r=LnDesign[p->lndsn].LnRgn[j]._R+p->vanishing*(BgR[BackgroundMode-BG_1] - LnDesign[p->lndsn].LnRgn[j]._R)/4;
								g=LnDesign[p->lndsn].LnRgn[j]._G+p->vanishing*(BgG[BackgroundMode-BG_1] - LnDesign[p->lndsn].LnRgn[j]._G)/4;
								b=LnDesign[p->lndsn].LnRgn[j]._B+p->vanishing*(BgB[BackgroundMode-BG_1] - LnDesign[p->lndsn].LnRgn[j]._B)/4;
								if(p->expand>1.0){
									pDC->SetPen(wxPen(wxColour(r,g,b),(int)floor((p->expand-1.0)/0.2+2.0),wxSOLID));
								}
								else{
									pDC->SetPen(wxPen(wxColour(r,g,b),2,wxSOLID));
								}
								pDC->DrawLine((int)floor(dispx0),(int)floor(dispy0),(int)floor(dispx1),(int)floor(dispy1));
							}
						}
						else {
							for(k=0;k<LnDesign[p->lndsn].LnRgn[j]._LGTH;k++){
								myP[k].x = (int)floor( dispx0 
									+ cos(theta)*LnDesign[p->lndsn].LnRgn[j]._PT[k].x*linerate - sin(theta)*LnDesign[p->lndsn].LnRgn[j]._PT[k].y) ;
								myP[k].y = (int)floor( dispy0 
									+ sin(theta)*LnDesign[p->lndsn].LnRgn[j]._PT[k].x*linerate + cos(theta)*LnDesign[p->lndsn].LnRgn[j]._PT[k].y) ;
							}
						}
						if(p->vanishing<4){
							r=LnDesign[p->lndsn].LnRgn[j]._R+p->vanishing*(BgR[BackgroundMode-BG_1] - LnDesign[p->lndsn].LnRgn[j]._R)/4;
							g=LnDesign[p->lndsn].LnRgn[j]._G+p->vanishing*(BgG[BackgroundMode-BG_1] - LnDesign[p->lndsn].LnRgn[j]._G)/4;
							b=LnDesign[p->lndsn].LnRgn[j]._B+p->vanishing*(BgB[BackgroundMode-BG_1] - LnDesign[p->lndsn].LnRgn[j]._B)/4;
							pDC->SetPen(wxPen(wxColour(r,g,b),1,wxSOLID));
							pDC->SetBrush(wxBrush(wxColour(r,g,b),wxSOLID));
							pDC->DrawPolygon(LnDesign[p->lndsn].LnRgn[j]._LGTH,myP,0,0,wxWINDING_RULE);
						}
					}
				}
			}
		}
	} 
	return false;
}

bool MyCanvas::DrawCurves(GParaCurve* p, wxMemoryDC* pDC)
{
	if(p==NULL){
		return true;
	}
	DrawOneCurve(p,pDC);
	if(p->next!=NULL){
		DrawCurves(p->next,pDC);
	}
	return false;
}

bool MyCanvas::DrawOneText(GText* p,wxMemoryDC* pDC)
{
	if(p==NULL){
		return true;
	}
	if(!relRect.Inside(p->tx,p->ty) || p->invisible){
		return true;
	}
	wxString tgt;
	EvaluateText(cns,p->str,tgt,false);
	RemoveYenCommaOnText(tgt);
	DrawMultiText(p,tgt,pDC,p->tx,p->ty);
	if(p->hilighted){
		int px,py;
		pDC->SetPen(wxPen(wxColour(TextHilColR,TextHilColG,TextHilColB),1,wxSOLID));
		pDC->SetBrush(*wxTRANSPARENT_BRUSH);
		GetMultiTextSize(tgt,pDC,&px,&py);
		pDC->DrawRectangle(p->tx - 1,p->ty,px+2,py);
	}
	return false;

}

bool MyCanvas::DrawTexts(GText* p,wxMemoryDC* pDC)
{
	if(p==NULL){
		return true;
	}
	DrawOneText(p,pDC);
	if(p->next!=0){
		DrawTexts(p->next,pDC);
	}
	return false;
}

bool MyCanvas::DrawMultiText(GText* p,wxString& st,wxMemoryDC* pDC,int px,int py)
{
	long length,height,descent;
	int i=0,j,offsety=0;
	unsigned char r,g,b;
	wxString subst;
	char*pp=(char*)st.c_str();
	int len=strlen(pp);
	for(j=0;j<len;j++){
		if(pp[j]=='\n' || pp[j]=='\r'){
			subst=mMid(st,i,j-i);
			if(p->vanishing<4){
				pDC->SetFont(wxFont((int)floor(p->fontsize*p->expand), wxFONTFAMILY_DEFAULT, wxFONTSTYLE_NORMAL, wxFONTWEIGHT_NORMAL, false, wxT(""),  wxFONTENCODING_DEFAULT));
				r=TextColR+p->vanishing*(BgR[0]-TextColR)/4;
				g=TextColG+p->vanishing*(BgG[0]-TextColG)/4;
				b=TextColB+p->vanishing*(BgB[0]-TextColB)/4;
				pDC->SetTextForeground(wxColour(r,g,b));
				wxString str1((char*)subst.c_str(),*wxConvCurrent);
				pDC->GetTextExtent(str1,&length,&height,&descent);
				pDC->DrawText(str1,px+p->offsetx-(int)floor(length*(p->expand-1.0)*0.25),py+offsety+p->offsety-(int)floor((height+descent)*(p->expand-1.0)*0.25));
				offsety +=(height+descent);
				i=j+1;
			}
		}
	}
	subst=mMid(st,i);
	if(p->vanishing<=4){
		pDC->SetFont(wxFont((int)floor(p->fontsize*p->expand), wxFONTFAMILY_DEFAULT, wxFONTSTYLE_NORMAL, wxFONTWEIGHT_NORMAL, false, wxT(""),  wxFONTENCODING_DEFAULT));
		pDC->SetTextForeground(wxColour(
			TextColR+p->vanishing*(BgR[0]-TextColR)/4,
			TextColG+p->vanishing*(BgG[0]-TextColG)/4,
			TextColB+p->vanishing*(BgB[0]-TextColB)/4));
		wxString str2((char*)subst.c_str(),*wxConvCurrent);
		pDC->GetTextExtent(str2,&length,&height,&descent);
		pDC->DrawText(str2,px+p->offsetx-(int)floor(length*(p->expand-1.0)*0.25),py+offsety+p->offsety-(int)floor((height+descent)*(p->expand-1.0)*0.25));
	}
	return false;
}

bool MyCanvas::GetMultiTextSize(wxString st,wxMemoryDC* pDC,int *px,int *py)
{
	*px=0;
	*py=0;
	long length,height,descent;
	int i=0,j;
	wxString subst;
	char*pp=(char*)st.c_str();
	int len=strlen(pp);
	for(j=0;j<len;j++){
		if(pp[j]=='\n' || pp[j]=='\r'){
			subst=mMid(st,i,j-i);
			wxString str1((char*)subst.c_str(),*wxConvCurrent);
			pDC->GetTextExtent(str1,&length,&height,&descent);
			i=j+1;
			*py +=(height+descent);
			if(*px<length){
				*px=length;
			}
		}
	}
	subst=mMid(st,i);
	wxString str2((char*)subst.c_str(),*wxConvCurrent);
	pDC->GetTextExtent(str2,&length,&height,&descent);
	*py +=(height+descent);
	if(*px<length){
		*px=length;
	}
	return false;
}


bool MyCanvas::DrawCompassCircle(wxMemoryDC* pDC)
{
	if(NOhilightedPoints==1){
		compassradius=(int)floor(sqrt(
			1.0*(compasscenterx-compasscursorx)*(compasscenterx-compasscursorx)+
			1.0*(compasscentery-compasscursory)*(compasscentery-compasscursory)));
	}
	else if(NOhilightedPoints==2){
		compasscenterx=compasscursorx;
		compasscentery=compasscursory;
	}
	else {
		return false;;
	}
	pDC->SetPen(AxisPen);
	pDC->SetBrush(*wxTRANSPARENT_BRUSH);
	pDC->DrawCircle(compasscenterx,compasscentery,compassradius);
	return false;
}
