//
// Find.cpp 
//
#include <math.h>
#include "wx/wx.h"
#include "incident.h"
#include "resource.h"
#include "KidsCindyCanvas.h"
#include "KidsCindyFrame.h"
#ifdef __WXMSW__
	#include "word.h"
#else
	#include "word_e.h"
#endif

// 0 : fade , 1 : right , 2 : left , 3 : top , 4 : bottom
enum{
	DIR_FADE=0,
	DIR_RIGHT,
	DIR_LEFT,
	DIR_TOP,
	DIR_BOTTOM
};

bool MyCanvas::FindAnotherMeet(GCircle* ci1, GLine *ln1,GPoint ** ptH)
{
	GIncident*ic1,*ic2;
	for(ic1=ci1->ics;ic1!=NULL;ic1=ic1->_icnext){
		for(ic2=ln1->ics;ic2!=NULL;ic2=ic2->_icnext){
			if(ic1->_icpt == ic2->_icpt){
				*ptH =ic1->_icpt;
				return true;
			}
		}
	}
	*ptH=NULL;
	return false;
}

bool MyCanvas::FindAnotherMeet(GCircle* ci1, GCircle *ci2,GPoint ** ptH)
{
	GIncident*ic1,*ic2;
	for(ic1=ci1->ics;ic1!=NULL;ic1=ic1->_icnext){
		for(ic2=ci2->ics;ic2!=NULL;ic2=ic2->_icnext){
			if(ic1->_icpt == ic2->_icpt){
				*ptH =ic1->_icpt;
				return true;
			}
		}
	}
	*ptH=NULL;
	return false;
}

bool MyCanvas::FindJoinFromCns(GConst* cn,GPoint* pt1,GPoint*pt2,GConst** cn1)
{
	if(cn==NULL){
		return false;
	}
	GConst *cncur;
	for(cncur=cn;cncur!=NULL;cncur=cncur->next){
		if(cncur->Const_Type==CONST_JOIN && cncur->PInput1==pt1 && cncur->PInput2==pt2){
			*cn1 = cncur;
			return true;
		}
		if(cncur->Const_Type==CONST_JOIN && cncur->PInput1==pt2 && cncur->PInput2==pt1){
			*cn1 = cncur;
			return true;
		}
	}
	return false;
}

bool MyCanvas::FindMeetFromCn(GConst* cn,GLine* ln1,GLine* ln2,GConst **cn1)
{
	if(cn==NULL){
		return true;
	}
	GConst *cncur;
	for(cncur=cn;cncur!=NULL;cncur=cncur->next){
		if(cncur->Const_Type==CONST_MEET && cncur->LInput1==ln1 && cncur->LInput2==ln2){
			*cn1 = cncur;
			return false;
		}
		else if(cncur->Const_Type==CONST_MEET && cncur->LInput1==ln2 && cncur->LInput2==ln1){
			*cn1 = cncur;
			return false;
		}
	}
	return true;
}

bool FindNameFromCns(GConst* cn,wxString& name,GConst** cn1)
{
	if(cn==NULL){
		return false;
	}
	GConst *cnp;
	for(cnp=cn;cnp!=NULL;cnp=cnp->next){
		if(cnp->COutput!=NULL){
			//printf("(%s==%s)=%d:",cnp->COutput->_name.c_str(),name.c_str(),(int)(mStrcmp(cnp->COutput->_name,name)));
			if(mStrcmp(cnp->COutput->_name,name)){
				*cn1=cnp;
				return true;
			}
		}
		if(cnp->LOutput!=NULL){
			if(mStrcmp(cnp->LOutput->_name,name)){
				*cn1=cnp;
				return true;
			}
		}
		if(cnp->POutput!=NULL){
			//printf("(%s==%s)=%d:",cnp->POutput->_name.c_str(),name.c_str(),(int)(mStrcmp(cnp->POutput->_name,name)));
			if(mStrcmp(cnp->POutput->_name,name)){
				*cn1=cnp;
				return true;
			}
		}
		if(cnp->CurveOutput!=NULL){
			if(mStrcmp(cnp->CurveOutput->_name,name)){
				*cn1=cnp;
				return true;
			}
		}
		if(cnp->TextOutput!=NULL){
			if(mStrcmp(cnp->TextOutput->_name,name)){
				*cn1=cnp;
				return true;
			}
		}
	}
	return false;
}

bool MyCanvas::FindParaFromCns(GConst* cn,GLine* ln1,GPoint* pt1,GConst** cn1)
{
	*cn1=NULL;
	if(cn==NULL){
		return false;
	}
	GConst *cncur;
	for(cncur=cn;cncur!=NULL;cncur=cncur->next){
		if(cncur->Const_Type==CONST_PARALLEL && cncur->LInput1==ln1 && cncur->PInput1==pt1){
			*cn1 = cncur;
			return true;
		}
	}
	return false;
}

bool MyCanvas::FindPerpFromCns(GConst* cn,GLine* ln1,GPoint* pt1,GConst** cn1)
{
	*cn1=NULL;
	if(cn==NULL){
		return false;
	}
	GConst *cncur;
	for(cncur=cn;cncur!=NULL;cncur=cncur->next){
		if(cncur->Const_Type==CONST_PERP && cncur->LInput1==ln1 && cncur->PInput1==pt1){
			*cn1 = cncur;
			return true;
		}
	}
	return false;
}

GPoint* MyCanvas::FindPtFromPts(GPoint* ptp,GPoint* pt){
	if(ptp==NULL || pt==NULL){
		return NULL;
	}
	if(ptp->xx * pt->yy==ptp->yy * pt->xx && ptp->yy * pt->zz==ptp->zz * pt->yy && ptp!=pt){
		return ptp;
	}
	else{
		return FindPtFromPts(ptp->next, pt);
	}
}

bool FindCiFromCn(GConst* cn,GCircle* ci,GConst **cn1)
{
	if(cn==NULL){
		return false;
	}

	if(cn->COutput==ci){
		*cn1=cn;
		return true;
	}
	if(cn->next!=NULL){
		return FindCiFromCn(cn->next,ci,cn1);
	}
	return false;
}

bool FindCnFromPt(GConst* cn,GPoint* pt,GConst** cn1)
{
	if(cn==NULL){
		return true;
	}
	GConst *cncur;
	*cn1=NULL;
	for(cncur=cn;cncur!=NULL;cncur=cncur->next){
		if(cncur->POutput==pt){
			*cn1 = cncur;
			return false;
		}
	}
	return true;
}

bool FindCurveFromCns(GConst* cn,GParaCurve* cu,GConst **cn1)
{
	if(cn==NULL){
		return false;
	}
	if(cn->CurveOutput==cu){
		*cn1=cn;
		return true;
	}
	if(cn->next!=NULL){
		return FindCurveFromCns(cn->next,cu,cn1);
	}
	return false;
}

bool FindLnFromCn(GConst* cn,GLine* ln,GConst **cn1)
{
	if(cn==NULL){
		return false;
	}

	if(cn->LOutput==ln){
		*cn1=cn;
		return true;
	}
	if(cn->next!=NULL){
		return FindLnFromCn(cn->next,ln,cn1);
	}
	return false;
}

bool FindPtFromCn(GConst* cn,GPoint* pt,GConst **cn1)
{
	if(cn==NULL){
		return false;
	}
	if(cn->POutput==pt){
		*cn1=cn;
		return true;
	}
	if(cn->next!=NULL){
		return FindPtFromCn(cn->next,pt,cn1);
	}
	return false;
}

bool MyCanvas::Find3PBisectorFromCns(GConst* cn,GPoint* pt1,GPoint* pt2,GPoint* pt3,GConst** cn1)
{
	*cn1=NULL;
	if(cn==NULL){
		return false;
	}
	GConst *cnp;
	for(cnp=cn;cnp!=NULL;cnp=cnp->next){
		if(cnp->Const_Type==CONST_3P_BISECTOR && cnp->PInput1==pt1 && cnp->PInput2==pt2 && cnp->PInput3==pt3){
			*cn1 = cnp;
			return true;
		}
	}
	return false;
}

bool MyCanvas::FindBisectorFromCns(GConst* cn,GLine* ln1,GLine* ln2,double dd1,GConst** cn1)
{
	*cn1=NULL;
	if(cn==NULL){
		return false;
	}
	GConst *cnp;
	for(cnp=cn;cnp!=NULL;cnp=cnp->next){
		if(cnp->Const_Type==CONST_BISECTOR && cnp->LInput1==ln1 && cnp->LInput2==ln2 && cnp->para1==CComplex(dd1,0.0)){
			*cn1 = cnp;
			return true;
		}
	}
	return false;
}

bool MyCanvas::FindTangentFromCns(GConst* cn,GCircle* ci,GPoint* pt,GConst** cn1)
{
	*cn1=NULL;
	if(cn==NULL){
		return false;
	}
	GConst *cnp;
	for(cnp=cn;cnp!=NULL;cnp=cnp->next){
		if(cnp->Const_Type==CONST_TANGENT && cnp->CInput1==ci && cnp->PInput1==pt){
			*cn1 = cnp;
			return true;
		}
	}
	return false;
}

bool FindCurveTangentFromCns(GConst* cn,GParaCurve* cu,GPoint* pt,GConst** cn1)
{
	*cn1=NULL;
	if(cn==NULL){
		return false;
	}
	GConst *cnp;
	for(cnp=cn;cnp!=NULL;cnp=cnp->next){
		if(cnp->Const_Type==CONST_CURVE_TANGENT && cnp->CurveInput1==cu && cnp->PInput1==pt){
			*cn1 = cnp;
			return true;
		}
	}
	return false;
}

double min(double a, double b);
double max(double a, double b);

bool MyCanvas::FindNextEffectFromCns()
{
	double geomx;
	double geomy;
	double dispx0;
	double dispy0;
	double dispx1;
	double dispy1;
	int dispx;
	int dispy;
	int length,height;
	wxPaintDC pDC(this);
	GConst *cnp;
	for(cnp=anim_cn->next;cnp!=NULL;cnp=cnp->next){
		switch(cnp->Const_Type){
		case CONST_EFFECT_POINT:
			anim_cn=cnp;
			if(cnp->anim_click==1){
				anim_wait=true;
			}
			else{
				anim_wait=false;
			}
			geomx=cnp->anim_entry->POutput->xz().real();
			geomy=cnp->anim_entry->POutput->yz().real();
			dispx=centerx+(int)floor((geomx-geomcx)/geomperdot);
			dispy=centery-(int)floor((geomy-geomcy)/geomperdot);
			cnp->anim_entry->POutput->expand=1.0;
			cnp->anim_entry->POutput->interval=0.2;
			if(cnp->anim_inout==0){
				switch(cnp->anim_direction){
				case DIR_FADE:
					cnp->anim_entry->POutput->vanishing=4;
					cnp->anim_entry->POutput->offsetx=0;
					cnp->anim_entry->POutput->offsety=0;
					break;
				case DIR_RIGHT:
					cnp->anim_entry->POutput->vanishing=0;
					cnp->anim_entry->POutput->offsetx=relRect.GetRight()-dispx+30;
					cnp->anim_entry->POutput->offsety=0;
					cnp->anim_entry->POutput->velocity=(relRect.GetRight()-dispx+30)/10;
					break;
				case DIR_LEFT:
					cnp->anim_entry->POutput->vanishing=0;
					cnp->anim_entry->POutput->offsetx=relRect.GetLeft()-dispx-30;
					cnp->anim_entry->POutput->offsety=0;
					cnp->anim_entry->POutput->velocity=(relRect.GetLeft()-dispx-30)/10;
					break;
				case DIR_TOP:
					cnp->anim_entry->POutput->vanishing=0;
					cnp->anim_entry->POutput->offsetx=0;
					cnp->anim_entry->POutput->offsety=relRect.GetTop()-dispy-30;
					cnp->anim_entry->POutput->velocity=(relRect.GetTop()-dispy-30)/10;
					break;
				case DIR_BOTTOM:
					cnp->anim_entry->POutput->vanishing=0;
					cnp->anim_entry->POutput->offsetx=0;
					cnp->anim_entry->POutput->offsety=relRect.GetBottom()-dispy+30;
					cnp->anim_entry->POutput->velocity=(relRect.GetBottom()-dispy+30)/10;
					break;
				}
			}
			else{
				switch(cnp->anim_direction){
				case DIR_FADE:
					cnp->anim_entry->POutput->vanishing=0;
					cnp->anim_entry->POutput->offsetx=0;
					cnp->anim_entry->POutput->offsety=0;
					break;
				case DIR_RIGHT:
					cnp->anim_entry->POutput->vanishing=0;
					cnp->anim_entry->POutput->offsetx=0;
					cnp->anim_entry->POutput->offsety=0;
					cnp->anim_entry->POutput->velocity=(relRect.GetRight()-dispx+30)/10;
					break;
				case DIR_LEFT:
					cnp->anim_entry->POutput->vanishing=0;
					cnp->anim_entry->POutput->offsetx=0;
					cnp->anim_entry->POutput->offsety=0;
					cnp->anim_entry->POutput->velocity=(relRect.GetLeft()-dispx-30)/10;
					break;
				case DIR_TOP:
					cnp->anim_entry->POutput->vanishing=0;
					cnp->anim_entry->POutput->offsetx=0;
					cnp->anim_entry->POutput->offsety=0;
					cnp->anim_entry->POutput->velocity=(relRect.GetTop()-dispy-30)/10;
					break;
				case DIR_BOTTOM:
					cnp->anim_entry->POutput->vanishing=0;
					cnp->anim_entry->POutput->offsetx=0;
					cnp->anim_entry->POutput->offsety=0;
					cnp->anim_entry->POutput->velocity=(relRect.GetBottom()-dispy+30)/10;
					break;
				}
			}
			return true;
			break;
		case CONST_EFFECT_LINE:
			anim_cn=cnp;
			if(cnp->anim_click==1){
				anim_wait=true;
			}
			else{
				anim_wait=false;
			}
			GetGeomXY(anim_cn->anim_entry->LOutput, &dispx0, &dispy0, &dispx1, &dispy1);
			cnp->anim_entry->LOutput->expand=1.0;
			cnp->anim_entry->LOutput->interval=0.2;
			if(cnp->anim_inout==0){
				switch(cnp->anim_direction){
				case DIR_FADE:
					cnp->anim_entry->LOutput->vanishing=4;
					cnp->anim_entry->LOutput->offsetx=0;
					cnp->anim_entry->LOutput->offsety=0;
					break;
				case DIR_RIGHT:
					cnp->anim_entry->LOutput->vanishing=0;
					cnp->anim_entry->LOutput->offsetx=relRect.GetRight()-(int)floor(min(dispx0,dispx1))+30;
					cnp->anim_entry->LOutput->offsety=0;
					cnp->anim_entry->LOutput->velocity=(relRect.GetRight()-(int)floor(min(dispx0,dispx1))+30)/10;
					break;
				case DIR_LEFT:
					cnp->anim_entry->LOutput->vanishing=0;
					cnp->anim_entry->LOutput->offsetx=relRect.GetLeft()-(int)floor(max(dispx0,dispx1))-30;
					cnp->anim_entry->LOutput->offsety=0;
					cnp->anim_entry->LOutput->velocity=(relRect.GetLeft()-(int)floor(max(dispx0,dispx1))-30)/10;
					break;
				case DIR_TOP:
					cnp->anim_entry->LOutput->vanishing=0;
					cnp->anim_entry->LOutput->offsetx=0;
					cnp->anim_entry->LOutput->offsety=relRect.GetTop()-(int)floor(max(dispy0,dispy1))-30;
					cnp->anim_entry->LOutput->velocity=(relRect.GetTop()-(int)floor(max(dispy0,dispy1))-30)/10;
					break;
				case DIR_BOTTOM:
					cnp->anim_entry->LOutput->vanishing=0;
					cnp->anim_entry->LOutput->offsetx=0;
					cnp->anim_entry->LOutput->offsety=relRect.GetBottom()-(int)floor(min(dispy0,dispy1))+30;
					cnp->anim_entry->LOutput->velocity=(relRect.GetBottom()-(int)floor(min(dispy0,dispy1))+30)/10;
					break;
				}
			}
			else{
				switch(cnp->anim_direction){
				case DIR_FADE:
					cnp->anim_entry->LOutput->vanishing=0;
					cnp->anim_entry->LOutput->offsetx=0;
					cnp->anim_entry->LOutput->offsety=0;
					break;
				case DIR_RIGHT:
					cnp->anim_entry->LOutput->vanishing=0;
					cnp->anim_entry->LOutput->offsetx=0;
					cnp->anim_entry->LOutput->offsety=0;
					cnp->anim_entry->LOutput->velocity=(relRect.GetRight()-(int)floor(min(dispx0,dispx1))+30)/10;
					break;
				case DIR_LEFT:
					cnp->anim_entry->LOutput->vanishing=0;
					cnp->anim_entry->LOutput->offsetx=0;
					cnp->anim_entry->LOutput->offsety=0;
					cnp->anim_entry->LOutput->velocity=(relRect.GetLeft()-(int)floor(max(dispx0,dispx1))-30)/10;
					break;
				case DIR_TOP:
					cnp->anim_entry->LOutput->vanishing=0;
					cnp->anim_entry->LOutput->offsetx=0;
					cnp->anim_entry->LOutput->offsety=0;
					cnp->anim_entry->LOutput->velocity=(relRect.GetTop()-(int)floor(max(dispy0,dispy1))-30)/10;
					break;
				case DIR_BOTTOM:
					cnp->anim_entry->LOutput->vanishing=0;
					cnp->anim_entry->LOutput->offsetx=0;
					cnp->anim_entry->LOutput->offsety=0;
					cnp->anim_entry->LOutput->velocity=(relRect.GetBottom()-(int)floor(min(dispy0,dispy1))+30)/10;
					break;
				}
			}
			return true;
			break;	
		case CONST_EFFECT_TEXT:
			PrepareDC(pDC);
			m_owner->PrepareDC(pDC);
			GetMultiTextSize(cnp->anim_entry->TextOutput->str,(wxMemoryDC*) &pDC, &length, &height);
			cnp->anim_entry->TextOutput->hilighted=false;
			anim_cn=cnp;
			if(cnp->anim_click==1){
				anim_wait=true;
			}
			else{
				anim_wait=false;
			}
			cnp->anim_entry->TextOutput->expand=1.0;
			cnp->anim_entry->TextOutput->interval=0.2;
			if(cnp->anim_inout==0){
				switch(cnp->anim_direction){
				case DIR_FADE:
					cnp->anim_entry->TextOutput->vanishing=4;
					cnp->anim_entry->TextOutput->offsetx=0;
					cnp->anim_entry->TextOutput->offsety=0;
					break;
				case DIR_RIGHT:
					cnp->anim_entry->TextOutput->vanishing=0;
					cnp->anim_entry->TextOutput->offsetx=relRect.GetRight()-cnp->anim_entry->TextOutput->tx+30;
					cnp->anim_entry->TextOutput->offsety=0;
					cnp->anim_entry->TextOutput->velocity=(relRect.GetRight()-cnp->anim_entry->TextOutput->tx+30)/10;
					break;
				case DIR_LEFT:
					cnp->anim_entry->TextOutput->vanishing=0;
					cnp->anim_entry->TextOutput->offsetx=relRect.GetLeft()-cnp->anim_entry->TextOutput->tx-length-30;
					cnp->anim_entry->TextOutput->offsety=0;
					cnp->anim_entry->TextOutput->velocity=(relRect.GetLeft()-cnp->anim_entry->TextOutput->tx-length-30)/10;
					break;
				case DIR_TOP:
					cnp->anim_entry->TextOutput->vanishing=0;
					cnp->anim_entry->TextOutput->offsetx=0;
					cnp->anim_entry->TextOutput->offsety=relRect.GetTop()-cnp->anim_entry->TextOutput->ty-height-30;
					cnp->anim_entry->TextOutput->velocity=(relRect.GetTop()-cnp->anim_entry->TextOutput->ty-height-30)/10;
					break;
				case DIR_BOTTOM:
					cnp->anim_entry->TextOutput->vanishing=0;
					cnp->anim_entry->TextOutput->offsetx=0;
					cnp->anim_entry->TextOutput->offsety=relRect.GetBottom()-cnp->anim_entry->TextOutput->ty+30;
					cnp->anim_entry->TextOutput->velocity=(relRect.GetBottom()-cnp->anim_entry->TextOutput->ty+30)/10;
					break;
				}
			}
			else{
				switch(cnp->anim_direction){
				case DIR_FADE:
					cnp->anim_entry->TextOutput->vanishing=0;
					cnp->anim_entry->TextOutput->offsetx=0;
					cnp->anim_entry->TextOutput->offsety=0;
					break;
				case DIR_RIGHT:
					cnp->anim_entry->TextOutput->vanishing=0;
					cnp->anim_entry->TextOutput->offsetx=0;
					cnp->anim_entry->TextOutput->offsety=0;
					cnp->anim_entry->TextOutput->velocity=(relRect.GetRight()-cnp->anim_entry->TextOutput->tx+30)/10;
					break;
				case DIR_LEFT:
					cnp->anim_entry->TextOutput->vanishing=0;
					cnp->anim_entry->TextOutput->offsetx=0;
					cnp->anim_entry->TextOutput->offsety=0;
					cnp->anim_entry->TextOutput->velocity=(relRect.GetLeft()-cnp->anim_entry->TextOutput->tx-length-30)/10;
					break;
				case DIR_TOP:
					cnp->anim_entry->TextOutput->vanishing=0;
					cnp->anim_entry->TextOutput->offsetx=0;
					cnp->anim_entry->TextOutput->offsety=0;
					cnp->anim_entry->TextOutput->velocity=(relRect.GetTop()-cnp->anim_entry->TextOutput->ty-height-30)/10;
					break;
				case DIR_BOTTOM:
					cnp->anim_entry->TextOutput->vanishing=0;
					cnp->anim_entry->TextOutput->offsetx=0;
					cnp->anim_entry->TextOutput->offsety=0;
					cnp->anim_entry->TextOutput->velocity=(relRect.GetBottom()-cnp->anim_entry->TextOutput->ty+30)/10;
					break;
				}
			}
			return true;
			break;
		case CONST_EFFECT_CIRCLE:
			cnp->anim_entry->COutput->hilighted=false;
			anim_cn=cnp;
			if(cnp->anim_click==1){
				anim_wait=true;
			}
			else{
				anim_wait=false;
			}
			int x,y,r;
			x=centerx+(int)floor((cnp->anim_entry->COutput->xx.real()-geomcx)/geomperdot);
			y=centery-(int)floor((cnp->anim_entry->COutput->yy.real()-geomcy)/geomperdot);
			r=(int)floor(cnp->anim_entry->COutput->rr.real()/geomperdot);
			cnp->anim_entry->COutput->expand=1.0;
			cnp->anim_entry->COutput->interval=0.2;
			if(cnp->anim_inout==0){
				switch(cnp->anim_direction){
				case DIR_FADE:
					cnp->anim_entry->COutput->vanishing=4;
					cnp->anim_entry->COutput->offsetx=0;
					cnp->anim_entry->COutput->offsety=0;
					break;
				case DIR_RIGHT:
					cnp->anim_entry->COutput->vanishing=0;
					cnp->anim_entry->COutput->offsetx=relRect.GetRight()-x+r+30;
					cnp->anim_entry->COutput->offsety=0;
					cnp->anim_entry->COutput->velocity=(relRect.GetRight()-x+r+30)/10;
					break;
				case DIR_LEFT:
					cnp->anim_entry->COutput->vanishing=0;
					cnp->anim_entry->COutput->offsetx=relRect.GetLeft()-x-r-30;
					cnp->anim_entry->COutput->offsety=0;
					cnp->anim_entry->COutput->velocity=(relRect.GetLeft()-x-r-30)/10;
					break;
				case DIR_TOP:
					cnp->anim_entry->COutput->vanishing=0;
					cnp->anim_entry->COutput->offsetx=0;
					cnp->anim_entry->COutput->offsety=relRect.GetTop()-y-r-30;
					cnp->anim_entry->COutput->velocity=(relRect.GetTop()-y-r-30)/10;
					break;
				case DIR_BOTTOM:
					cnp->anim_entry->COutput->vanishing=0;
					cnp->anim_entry->COutput->offsetx=0;
					cnp->anim_entry->COutput->offsety=relRect.GetBottom()-y+r+30;
					cnp->anim_entry->COutput->velocity=(relRect.GetBottom()-y+r+30)/10;
					break;
				}
			}
			else{
				switch(cnp->anim_direction){
				case DIR_FADE:
					cnp->anim_entry->COutput->vanishing=0;
					cnp->anim_entry->COutput->offsetx=0;
					cnp->anim_entry->COutput->offsety=0;
					break;
				case DIR_RIGHT:
					cnp->anim_entry->COutput->vanishing=0;
					cnp->anim_entry->COutput->offsetx=0;
					cnp->anim_entry->COutput->offsety=0;
					cnp->anim_entry->COutput->velocity=(relRect.GetRight()-x+r+30)/10;
					break;
				case DIR_LEFT:
					cnp->anim_entry->COutput->vanishing=0;
					cnp->anim_entry->COutput->offsetx=0;
					cnp->anim_entry->COutput->offsety=0;
					cnp->anim_entry->COutput->velocity=(relRect.GetLeft()-x-r-30)/10;
					break;
				case DIR_TOP:
					cnp->anim_entry->COutput->vanishing=0;
					cnp->anim_entry->COutput->offsetx=0;
					cnp->anim_entry->COutput->offsety=0;
					cnp->anim_entry->COutput->velocity=(relRect.GetTop()-y-r-30)/10;
					break;
				case DIR_BOTTOM:
					cnp->anim_entry->COutput->vanishing=0;
					cnp->anim_entry->COutput->offsetx=0;
					cnp->anim_entry->COutput->offsety=0;
					cnp->anim_entry->COutput->velocity=(relRect.GetBottom()-y+r+30)/10;
					break;
				}
			}
			return true;
			break;
		case CONST_EFFECT_CURVE:
			break;
		}
	}
	for(cnp=cns;cnp!=NULL;cnp=cnp->next){
		switch(cnp->Const_Type){
		case CONST_EFFECT_POINT:
			cnp->anim_entry->POutput->offsetx=0;
			cnp->anim_entry->POutput->offsety=0;
			cnp->anim_entry->POutput->vanishing=0;
			break;
		case CONST_EFFECT_LINE:
			cnp->anim_entry->LOutput->offsetx=0;
			cnp->anim_entry->LOutput->offsety=0;
			cnp->anim_entry->LOutput->vanishing=0;
			break;
		case CONST_EFFECT_TEXT:
			cnp->anim_entry->TextOutput->offsetx=0;
			cnp->anim_entry->TextOutput->offsety=0;
			cnp->anim_entry->TextOutput->vanishing=0;
			break;
		case CONST_EFFECT_CIRCLE:
			cnp->anim_entry->COutput->offsetx=0;
			cnp->anim_entry->COutput->offsety=0;
			cnp->anim_entry->COutput->vanishing=0;
			break;
		case CONST_EFFECT_CURVE:
			break;
		}
	}
	wxStartTimer();
	do {;
	} while (wxGetElapsedTime(false)<1000);
	Click4NewSheet=true;
	anim_wait=false;
	anim_cn=NULL;
	return false;
}
